!     Last change:  09 May 2006   15:59   
MODULE Direct_lib
CONTAINS
REAL*8 FUNCTION DirectG(Cdim,z0,z1,z2)
!--------------------------------------------------------
!     Compute direct contribution G kernel
!--------------------------------------------------------
IMPLICIT NONE
REAL*8				:: DPI,PI2
PARAMETER			(DPI=3.141592653589793238D0, PI2=DPI*2.0D0)
INTEGER,INTENT(IN)	:: Cdim
REAL*8,INTENT(IN)		:: z0(Cdim)				! colloc ponit coordinates (x,y)
REAL*8,INTENT(IN)		:: z1(Cdim),z2(Cdim)	! integration limits, lower upper resp. (x,y)
REAL*8				:: nz(Cdim)				! normal vector (x,y)
REAL*8				:: Dx,Dy,al,x11,x12,x21,x22,r1,r2,d,t1,t2,ds,dtheta,aa,bb

Dx = z2(1)-z1(1)
Dy = z2(2)-z1(2)
al = DSQRT( Dx*Dx + Dy*Dy )
nz(1) =  Dy/al 
nz(2) = -Dx/al 

!**************** <LIU /> *******************
     ! do j = 1, nj

     !  jind = jnod(j)

     !   al = sqrt((y(1,node(1,jind))-y(1,node(2,jind)))**2 + (y(2,node(1,jind))-y(2,node(2,jind)))**2)

     !  do i = 1, ni

     !     iind = inod(i)

          x11 = z1(1)-z0(1) !y(1,node(1,jind)) - x(1,iind)
          x21 = z1(2)-z0(2) !y(2,node(1,jind)) - x(2,iind)
          x12 = z2(1)-z0(1) !y(1,node(2,jind)) - x(1,iind)
          x22 = z2(2)-z0(2) !y(2,node(2,jind)) - x(2,iind)

          r1 =  Dsqrt(x11**2 + x21**2)
          r2 =  Dsqrt(x12**2 + x22**2)
          d  =  x11*nz(1) + x21*nz(2) ! x11*dnorm(1,jind) + x21*dnorm(2,jind)
          t1 = -x11*nz(2) + x21*nz(1) !-x11*dnorm(2,jind) + x21*dnorm(1,jind)
          t2 = -x12*nz(2) + x22*nz(1) !-x12*dnorm(2,jind) + x22*dnorm(1,jind)

	    ds = Dabs(d)
            dtheta = Datan2(ds*al,ds**2+t1*t2)

          aa = (-dtheta*ds + al + t1*Dlog(r1)-t2*Dlog(r2))/pi2
	    !if(d .lt. 0.) dtheta = -dtheta
	    !bb = -dtheta/pi2
		
		DirectG = aa


	 !   if(iind .eq. jind) bb = 0.5

	 ! if(bc(1,jind) .eq. 1.) then
          !ax(i) = ax(i) - aa*u(j)
          !if(icell.eq.jcell .and. isw.eq.1) then
          !  amat(i,j) = - aa
          !endif
	 ! else if(bc(1,jind) .eq. 2.) then
     !     ax(i) = ax(i) + bb*u(j)
     !     if(icell.eq.jcell .and. isw.eq.1) then
     !       amat(i,j) =   bb
     !     endif
	 ! endif

	 ! enddo

	!enddo
!**************** <LIU /END> *******************
!DirectG = 1/(2.0*PI) * (cLOG(conjg(z0-z2)/abs(z0-z2))*(z0-z2)+z2-cLOG(conjg(z0-z1)/abs(z0-z1))*(z0-z1)-z1)
RETURN
END FUNCTION DirectG

REAL*8 FUNCTION DirectF(Cdim,z0,z1,z2)
!--------------------------------------------------------
!     Compute direct contribution F kernel
!--------------------------------------------------------
IMPLICIT NONE
REAL*8				:: DPI,PI2
PARAMETER			(DPI=3.141592653589793238D0, PI2=DPI*2.0D0)
INTEGER,INTENT(IN)	:: Cdim
REAL*8,INTENT(IN)		:: z0(Cdim)				! colloc ponit coordinates (x,y)
REAL*8,INTENT(IN)		:: z1(Cdim),z2(Cdim)	! integration limits, lower upper resp. (x,y)
REAL*8				:: nz(Cdim)				! normal vector (x,y)
REAL*8				:: Dx,Dy,al,x11,x12,x21,x22,r1,r2,d,t1,t2,ds,dtheta,aa,bb

Dx = z2(1)-z1(1)
Dy = z2(2)-z1(2)
al = DSQRT( Dx*Dx + Dy*Dy )
nz(1) =  Dy/al 
nz(2) = -Dx/al 

!**************** <LIU /> *******************
     ! do j = 1, nj

     !  jind = jnod(j)

     !   al = sqrt((y(1,node(1,jind))-y(1,node(2,jind)))**2 + (y(2,node(1,jind))-y(2,node(2,jind)))**2)

     !  do i = 1, ni

     !     iind = inod(i)

          x11 = z1(1)-z0(1) !y(1,node(1,jind)) - x(1,iind)
          x21 = z1(2)-z0(2) !y(2,node(1,jind)) - x(2,iind)
          x12 = z2(1)-z0(1) !y(1,node(2,jind)) - x(1,iind)
          x22 = z2(2)-z0(2) !y(2,node(2,jind)) - x(2,iind)

          r1 =  Dsqrt(x11**2 + x21**2)
          r2 =  Dsqrt(x12**2 + x22**2)
          d  =  x11*nz(1) + x21*nz(2) ! x11*dnorm(1,jind) + x21*dnorm(2,jind)
          t1 = -x11*nz(2) + x21*nz(1) !-x11*dnorm(2,jind) + x21*dnorm(1,jind)
          t2 = -x12*nz(2) + x22*nz(1) !-x12*dnorm(2,jind) + x22*dnorm(1,jind)

	    ds = Dabs(d)
            dtheta = Datan2(ds*al,ds**2+t1*t2)

          !aa = (-dtheta*ds + al + t1*Dlog(r1)-t2*Dlog(r2))/pi2
	    if(d .lt. 0.) dtheta = -dtheta
	    bb = -dtheta/pi2
	 !   if(iind .eq. jind) bb = 0.5

		DirectF = bb

	 ! if(bc(1,jind) .eq. 1.) then
          !ax(i) = ax(i) - aa*u(j)
          !if(icell.eq.jcell .and. isw.eq.1) then
          !  amat(i,j) = - aa
          !endif
	 ! else if(bc(1,jind) .eq. 2.) then
     !     ax(i) = ax(i) + bb*u(j)
     !     if(icell.eq.jcell .and. isw.eq.1) then
     !       amat(i,j) =   bb
     !     endif
	 ! endif

	 ! enddo

	!enddo
!**************** <LIU /END> *******************
!DirectF = nz * ( -1/(2.0*PI) * (cLOG(conjg(z0-z2)/abs(z0-z2))-cLOG(conjg(z0-z1)/abs(z0-z1))) )  !conjg(z0-z1)/abs
RETURN
END FUNCTION DirectF


SUBROUTINE Direct(Cdim,z0,z1,z2,bc,i,j,Kernel)
!--------------------------------------------------------
!     Compute direct contribution G kernel
!--------------------------------------------------------
IMPLICIT NONE
REAL*8				:: DPI,PI2,PI
PARAMETER			(PI=3.141592653589793238, DPI=3.141592653589793238D0, PI2=DPI*2.0D0)
INTEGER,INTENT(IN)	:: Cdim
REAL*8,INTENT(IN)		:: z0(Cdim)				! colloc ponit coordinates (x,y)
REAL*8,INTENT(IN)		:: z1(Cdim),z2(Cdim)	! integration limits, lower upper resp. (x,y)
REAL*8				:: nz(Cdim)				! normal vector (x,y)
INTEGER,INTENT(IN)	:: bc					! boundary condition
INTEGER,INTENT(IN)	:: i,j					! i and j elements
REAL*8,INTENT(OUT)		:: Kernel				! G or F kernel value
REAL*8				:: Dx,Dy,al,x11,x12,x21,x22,r1,r2,d,t1,t2,ds,dtheta,aa,bb

Dx = z2(1)-z1(1)
Dy = z2(2)-z1(2)
al = DSQRT( Dx*Dx + Dy*Dy )
nz(1) =  Dy/al 
nz(2) = -Dx/al 

!**************** <LIU /> *******************
     ! do j = 1, nj

     !  jind = jnod(j)

     !   al = sqrt((y(1,node(1,jind))-y(1,node(2,jind)))**2 + (y(2,node(1,jind))-y(2,node(2,jind)))**2)

     !  do i = 1, ni

     !     iind = inod(i)

          x11 = z1(1)-z0(1) !y(1,node(1,jind)) - x(1,iind)
          x21 = z1(2)-z0(2) !y(2,node(1,jind)) - x(2,iind)
          x12 = z2(1)-z0(1) !y(1,node(2,jind)) - x(1,iind)
          x22 = z2(2)-z0(2) !y(2,node(2,jind)) - x(2,iind)

          r1 =  Dsqrt(x11**2 + x21**2)
          r2 =  Dsqrt(x12**2 + x22**2)
          d  =  x11*nz(1) + x21*nz(2) ! x11*dnorm(1,jind) + x21*dnorm(2,jind)
          t1 = -x11*nz(2) + x21*nz(1) !-x11*dnorm(2,jind) + x21*dnorm(1,jind)
          t2 = -x12*nz(2) + x22*nz(1) !-x12*dnorm(2,jind) + x22*dnorm(1,jind)

	    ds = Dabs(d)
            dtheta = Datan2(ds*al,ds**2+t1*t2)

          aa = (-dtheta*ds + al + t1*Dlog(r1)-t2*Dlog(r2))/pi2
	    if(d .lt. 0.) dtheta = -dtheta
	    bb = -dtheta/pi2
		
!		DirectG = aa

	    if(i .eq. j) bb = 0.5

	  if(bc .eq. 1) then	! Dirichlet
          Kernel = -aa
		  !ax(i) = ax(i) - aa*u(j)
          !if(icell.eq.jcell .and. isw.eq.1) then
          !  amat(i,j) = - aa
          !endif
	  else if(bc .eq. 0) then	! Newmann
          Kernel = bb
		  !ax(i) = ax(i) + bb*u(j)
          !if(icell.eq.jcell .and. isw.eq.1) then
          !  amat(i,j) =   bb
          !endif
	  endif

	 ! enddo

	!enddo
!**************** <LIU /END> *******************
!DirectG = 1/(2.0*PI) * (cLOG(conjg(z0-z2)/abs(z0-z2))*(z0-z2)+z2-cLOG(conjg(z0-z1)/abs(z0-z1))*(z0-z1)-z1)
RETURN
END SUBROUTINE Direct
END MODULE Direct_lib