!
!	Este elemento calcula el Potencial electrico como un 
!	problema de difusion pura
!
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      SubRoutine PoissonFEM_2                                 &
                ( AE,BE,MaxLRows,XLL,NDim,iDofT,NodELT,       & 
                  Sol0,Sol1,CommonPar,                        &  
                  Param,JParam,DelT,DTm,Time)
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT REAL*8 (A-H,O-Z)

	Parameter (PI = 3.141592653589793238D0)
!      Parameter (Theta = 1.0D0 )
      Parameter (Ls1 = 1 )
      Parameter (Ls2 = 0 )
      Parameter (iT  = 1 )  ! Posision del Dof de Temperatura
!     NdimE: dimensionality of the triangle element,
!     it could be hapen that we use a 2d element in a 3d problem. 
!     NGP= Number of gauus points
! dependeria de Ndim y Integration order rule
! los dos tendrian que ir en ElemLib, porque se necesita
! la dimension del elemento, No esta implicito en el tipo de elemento
!  usado, aunque esto hace que no se pueda usar el mismo codigo
! para 2D y 3D
! OPCION 2D
!      Parameter (NodEL = 6 ); Parameter (NdimE = 2 ); Parameter (NGP = 7 )
! OPCION 3D
!      Parameter (NodEL = 10 ); Parameter (NdimE = 3 ); Parameter (NGP = 11 )
! OnlyVertex indicates a geometric interpolation with only vertex nodes 
      Logical OnlyVertex
! iSimplex = 0 -> The element is a Simplex
! iSimplex = 1 -> The element is a Hipercube
! iBU: use bubble function
      Parameter ( iSimplex = 0, iBU = 0 , OnlyVertex = .True. )     
      Real*8 Jac(Ndim,Ndim)
      DIMENSION AE(MaxLRows,MaxLRows),BE(MaxLRows),                       &
       XLL(1),Sol0(1),Sol1(1),                                            &
       Param(1), JParam(1),CommonPar(1),                                  &
       Psi(Ndim,11),W(11),XL(Ndim*(NodELT+1)),           &  
       Fi1(NodElT),Fi2(NodElT),dFi2i(Ndim),dFi2j(Ndim),                   &
       dFi1i(Ndim),dFi1j(Ndim),dFi1_G(Ndim,NodElT),dFi1_L(Ndim,NodElT),   &
       dFi2_L(Ndim,NodElT),dFi2_G(Ndim,NodELT),UX(Ndim*NodELT)

!  Real*8 , Static :: Mass(10,10),MassL(10)
!  Static iFirst
!  Real*8 , Save :: Mass(10,10),MassL(10)
!  Save iFirst
  Real*8 :: Mass(10,10),MassL(10)
  Integer iFirst


    NodEl=NodElT
    NDimE=Ndim

    OpTi=1.0d0 !*Dtm
! nci do variable,  number of coordinate index
      ep      = CommonPar(1)

     NdimE1  = Ndim + 1
     NodP    = NdimE1
     NodG    = NodP


  If (Ndim < 3) Then
      NGP =7
    Else
      NGP =11
  EndIf

!   Psi: Gauss Points Matrix, W: Weights
    Call GaussRule (Psi,W,NdimE,NGP,iSimplex)    
	dFi1_L = 0.0D0
	dFi1_G = 0.0D0
!--------------------------
      LoopGaussPoints: Do nG = 1, NGP
!--------------------------
!     dFi1_L = first derivatives with respect to intrinsic Local coordinates
!              refers to linear shape functions
!     dFi1_G = first derivatives with respect to Global coordinates
!     dFi2_L = first derivatives with respect to intrinsic Local coordinates
!              refers to Cuadratic shape functions

	  dFi2_L = 0.0D0
	  dFi2_G = 0.0D0
      Call LocalShapeDer(NodEL,NdimE,dFi2_L,PSI(1,nG),2,iBu)

      if (nG .eq. 1) Call LocalShapeDer(NodEL,NdimE,dFi1_L,PSI(1,nG),1,iBu)
      if (OnlyVertex) Then 
          if (nG .eq. 1) Call Jacobian(Jac,Det,NdimE,NodG,XLL,dFi1_L)
      Else
          Call Jacobian (Jac,Det,NdimE,NodG,XLL,dFi2_L)
      Endif
      if (nG .eq. 1) Call GlobalShapeDer(NodG,NdimE,dFi1_L,dFi1_G,Jac)
      Call GlobalShapeDer (NodEL,NdimE,dFi2_L,dFi2_G,Jac)
      Call ShapeF (NodEL,NdimE,Fi1,PSI(1,nG),1,iBu)
      Call ShapeF (NodEL,NdimE,Fi2,PSI(1,nG),2,iBu)

		DV=Det*W(nG)

      LoopRow: Do i=1,NodEL
        ipRowT = (i-1)*iDofT + iT
        Fi2i = Fi2(i)

        LoopCol: Do j=1,NodEL
         ipColT = (j-1)*iDofT + iT
  
         GradFi_GradFj= 0.0d0
         Do nci=1, NdimE
           GradFi_GradFj = GradFi_GradFj + dFi2_G(nci,i) * dFi2_G(nci,j) 
         Enddo                                            

	       AE(ipRowT , ipColT)= AE(ipRowT , ipColT) + ep * GradFi_GradFj * DV
       
        End do LoopCol

!-----------------------------------------------
     End do LoopRow
!--------------------------
   EndDo LoopGaussPoints
!--------------------------

  Return
 End

!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
